/*
 *  RapidMiner PaREn Automatic System Construction Extension 
 *
 *  Copyright (C) 2009-2010 by Deutsches Forschungszentrum fuer
 *  Kuenstliche Intelligenz GmbH or its licensors, as applicable.
 *  
 *  This is free software: you can redistribute it and/or modify 
 *  it under the terms of the GNU Affero General Public License as published by 
 *  the Free Software Foundation, either version 3 of the License, or 
 *  (at your option) any later version. 
 *  
 *  You should have received a copy of the GNU Affero General Public License 
 *  along with this software. If not, see <http://www.gnu.org/licenses/. 
 */
package de.dfki.madm.paren.casebase;

import java.io.IOException;
import java.io.InputStream;

import com.rapidminer.operator.AbstractIOObject;
import com.rapidminer.operator.IOObject;
import com.rapidminer.operator.OperatorDescription;
import com.rapidminer.operator.OperatorException;
import com.rapidminer.operator.io.AbstractReader;

/**
 * Just a convience Operator for reading the casebase.
 * @author Alexander Arimond
 *
 */

public class ReadCaseBase extends AbstractReader<CaseBase>{

	public ReadCaseBase(OperatorDescription description){
		super(description, CaseBase.class);
	}
	
	public ReadCaseBase(OperatorDescription description,
			Class<? extends IOObject> generatedClass) {
		super(description, CaseBase.class);
	}

	@Override
	public CaseBase read() throws OperatorException {
		
		try{
//			//XMLSerialization.init(ClassLoader.getSystemClassLoader())
//			
//			ExampleSet exampleSet = (ExampleSet) AbstractIOObject.read(new File("casebase.ioo"));
//			CaseBase casebase = new CaseBase(exampleSet);
//
//			File base = new File("YOUR PATH");
//			
//			File processesFolder = new File(base, "data/processes");
//			File preprocessesFolder = new File(base, "data/preprocesses");
//			File optimizeFolder = new File(base, "data/optimize");
//
//
//			String [] classifierNames = new String [] {"DecisionTree", // ,"Default",  
//					 "LibSVM", "NaiveBayes", "NearestNeighbors", 
//					"NeuralNetImproved", "OneR", "RandomForest-Weka", "RandomForest"};
//
//
//			for (int i = 0; i < classifierNames.length; i++){
//				//			Process process = new Process(new File(processesFolder, classifierNames[i] + ".rmp"));
//				//			Process preprocess = new Process(new File(preprocessesFolder, classifierNames[i] + ".rmp"));
//				Process process = getProcessFromFile(new File(processesFolder, classifierNames[i] + ".rmp"));
//				Process preprocess = getProcessFromFile(new File(preprocessesFolder, classifierNames[i] + ".rmp"));
//				SimpleResultObject params = (SimpleResultObject) readIOObject(new File(optimizeFolder, classifierNames[i] + ".ioo"));
//				//AbstractIOObject.read(new File(optimizeFolder, classifierNames[i] + ".ioo"));
//				casebase.addClassifier(classifierNames[i], preprocess, process, params);
//			} 

		    CaseBase casebase = (CaseBase)readIOObjectFromResource("com/rapidminer/resources/data/casebase.ioo");
		    
			//		class SimpleIOObject extends AbstractIOObject{
			//
			//			@Override
			//			public Annotations getAnnotations() {
			//				return null;
			//			}
			//			
			//		}
			//SimpleIOObject writer = new SimpleIOObject();
			//writer.write(new FileOutputStream(new File("casebase2.ioo")));
			return casebase;
		}catch(Exception e){
			throw new OperatorException("read casebase failed", e);
		}
	}
	
//	// for some reason new Process(file) didnt work here
//	private  Process getProcessFromFile(File file) throws FileNotFoundException, IOException, XMLException{
//		return new Process(readContent(new FileInputStream(file)));
//	}
	
//    private  String readContent(InputStream inputStream) throws IOException {
//        String content = "";
//        BufferedReader reader = new BufferedReader(new InputStreamReader(inputStream));
//        String line;
//        while((line = reader.readLine()) != null) {
//            content += line;
//        }
//        reader.close();
//        return content;
//    }

//    private IOObject readIOObject(final File file) throws IOException {
//        return AbstractIOObject.read(new AbstractIOObject.InputStreamProvider() {
//            @Override
//            public InputStream getInputStream() throws IOException {
//                return new FileInputStream(file);
//            }
//        });
//    }

    private static IOObject readIOObjectFromResource(final String resource) throws IOException {
        return AbstractIOObject.read(new AbstractIOObject.InputStreamProvider() {
            @Override
            public InputStream getInputStream() throws IOException {
                return this.getClass().getClassLoader().getResourceAsStream(resource);
            }
        });
    }
    

}
