/*
 *  RapidMiner PaREn Automatic System Construction Extension 
 *
 *  Copyright (C) 2009-2010 by Deutsches Forschungszentrum fuer
 *  Kuenstliche Intelligenz GmbH or its licensors, as applicable.
 *  
 *  This is free software: you can redistribute it and/or modify 
 *  it under the terms of the GNU Affero General Public License as published by 
 *  the Free Software Foundation, either version 3 of the License, or 
 *  (at your option) any later version. 
 *  
 *  You should have received a copy of the GNU Affero General Public License 
 *  along with this software. If not, see <http://www.gnu.org/licenses/. 
 */
package de.dfki.madm.paren.landmarking;

import java.util.Map;

import com.rapidminer.example.ExampleSet;
import com.rapidminer.operator.Operator;
import com.rapidminer.operator.OperatorCreationException;
import com.rapidminer.operator.OperatorException;
import com.rapidminer.operator.learner.bayes.NaiveBayes;
import com.rapidminer.tools.OperatorService;

/**
 * This landmark learner is a {@link NaiveBayes} learner.
 * 
 * @author Sarah Daniel
 * 
 */
public class NaiveBayesLm extends AbstractLandmarker {

    public NaiveBayesLm(ExampleSet exampleSet, Map<String, String> parameters) throws OperatorCreationException, OperatorException {

            this.name = LandmarkingParameters.PARAMETER_NAIVEBAYES_LM;

            Operator learner = OperatorService.createOperator(NaiveBayes.class);
            exampleSet = normalizeExampleSet(exampleSet, parameters);

            learnExampleSet(exampleSet, learner, parameters);

    }
}
